package cn.com.qmth.examcloud.api.commons.enums;

/**
 * @ClassName ExamType
 * @Author nikang
 * @Date 2018/9/21 17:56
 * @Version 3.0
 */
public enum ExamType {
    /**
     * 传统考试
     */
    TRADITION("传统考试"),
    /**
     * 在线考试
     */
    ONLINE("在线考试"),
    /**
     * 在线练习
     */
    PRACTICE("练习"),

    /**
     * 离线考试
     */
    OFFLINE("离线考试"),

    /**
     * 分布式印刷考试
     */
    PRINT_EXAM("分布式印刷考试"),

    /**
     * 在线作业
     */
    ONLINE_HOMEWORK("在线作业");

    private String title;

    private ExamType(String title) {
        this.title = title;
    }

    public static ExamType strToEnum(String str) {
        for (ExamType examType : ExamType.values()) {
            if (examType.name().equals(str)) {
                return examType;
            }
        }
        return null;
    }

    public static String getTitle(String name) {
        for (ExamType examType : ExamType.values()) {
            if (examType.name().equals(name)) {
                return examType.title;
            }
        }
        return null;
    }
}
