package cn.com.qmth.examcloud.api.commons.security.bean;

import cn.com.qmth.examcloud.api.commons.exchange.JsonSerializable;

import java.util.HashSet;
import java.util.Optional;
import java.util.Set;
import java.util.stream.Collectors;

public class UserDataRule implements JsonSerializable {

    private static final long serialVersionUID = 1L;

    /**
     * “默认全部”状态
     */
    private boolean globalStatus;

    /**
     * 关联ID列表
     */
    private Set<Long> refIds;

    /**
     * 断言“当前查询”是否返回空的数据结果集
     */
    public boolean assertEmptyQueryResult() {
        if (!globalStatus && this.getRefIds().isEmpty()) {
            return true;
        }

        return false;
    }

    /**
     * 断言“refIds”是否作为查询条件
     */
    public boolean assertNeedQueryRefIds() {
        if (!globalStatus && !this.getRefIds().isEmpty()) {
            return true;
        }

        return false;
    }

    public boolean getGlobalStatus() {
        return globalStatus;
    }

    public void setGlobalStatus(boolean globalStatus) {
        this.globalStatus = globalStatus;
    }

    public Set<Long> getRefIds() {
        if (refIds == null) {
            return new HashSet<>();
        }
        return refIds;
    }

    public void setRefIds(Set<Long> refIds) {
        this.refIds = refIds;
    }

    /**
     * 返回String值类型的“refIds”集合
     */
    public Set<String> stringRefIds() {
        return Optional.ofNullable(refIds)
                .orElse(new HashSet<>())
                .stream()
                .map(e -> String.valueOf(e))
                .collect(Collectors.toSet());
    }

    @Override
    public String toString() {
        return "globalStatus = " + globalStatus + ", refIds = " + refIds;
    }

}
