package cn.com.qmth.examcloud.support;

/**
 * @Description 系统常量
 * @Author lideyin
 * @Date 2019/12/11 15:52
 * @Version 1.0
 */
public interface Constants {

    /**
     * 参数错误
     */
    String OE_CODE_400 = "000400";

    String ERROR_MSG = "error_message";

    String isTrue = "true";

    String isFalse = "false";

    /**
     * face++ 人脸比对API并发次数超过上限
     */
    String FACE_COMPARE_CONCURRENCY_LIMIT_EXCEEDED = "CONCURRENCY_LIMIT_EXCEEDED";

    /**
     * face++
     * api_key没有调用本API的权限，具体原因为：用户自己禁止该api_key调用、管理员禁止该api_key调用、由于账户余额不足禁止调用。
     */
    String FACE_COMPARE_AUTHORIZATION_ERROR = "AUTHORIZATION_ERROR";

    // 抓拍照片的又拍云id
    String CAPTURE_PHOTO_UPYUN_SITEID = "capturePhoto";

    /**
     * 网考考试资源文件siteId
     */
    String OE_SITEID = "oe";

    /**
     * 照片处理中状态码
     */
    String CAPTURE_PROCESSING_STATUS_CODE = "101222";

    /**
     * 考试未结束状态码
     */
    String EXAM_RECORD_NOT_END_STATUS_CODE = "101333";

    /**
     * 交卷处理中
     */
    String PROCESSING_EXAM_RECORD_CODE = "S-101000";

    /**
     * 通用成功编码
     */
    String COMMON_SUCCESS_CODE = "000000";

    /**
     * 活体检测方案key
     */
    String IDENTIFICATION_OF_LIVING_BODY_SCHEME_KEY = "IDENTIFICATION_OF_LIVING_BODY_SCHEME";

    /**
     * 默认的百度活检阈值
     */
    Double DEFAULT_BAIDU_FACELIVENESS_THRESHOLD = 0.39;

    /**
     * 小程序作答文件上传id
     */
    String MINI_PROGRAM_ANWSER_SITEID = "miniProgramAnwser";

    /**
     * 证件隐私模式key
     */
    String ID_NUMBER_PRIVATE_MODE_KEY = "ID_NUMBER_PRIVATE_MODE";

    /**
     * 客户端请求中User-Agent特征值
     */
    String ELECTRON_EXAM_SHELL = "electron-exam-shell";

    /**
     * 虚拟摄像头信息
     */
    String VM_CAMERA_WARN = "[{\"name\":\"虚拟摄像头信息超长！\",\"pid\":\"\",\"vid\":\"\"}]";

    /**
     * 虚拟摄像头信息 长度限制值
     */
    int VM_CAMERA_SIZE_LIMIT = 800;

    /**
     * 人脸活体检测时间随机范围，最大分钟数
     */
    int MAX_FACE_LIVE_VERIFY_MINUTE = 4;

    /**
     * 开考时人脸识别API
     */
    String FACE_VERIFY_API_PROVIDER = "FACE_VERIFY_API_PROVIDER";

    /**
     * 抓拍时人脸比对API
     */
    String FACE_COMPARE_API_PROVIDER = "FACE_COMPARE_API_PROVIDER";

    /**
     * 百度人脸比对通过阈值
     */
    String BAIDU_EXPECT_FACE_COMPARE_SCORE = "BAIDU_EXPECT_FACE_COMPARE_SCORE";

    /**
     * 网考-用于环境监测的考试记录ID
     */
    Long OE_ENV_CHECK_EXAM_RECORD_DATA_ID = 0L;

    /**
     * 网考-用于环境监测的题号
     */
    int OE_ENV_CHECK_QUESTION_ORDER = 1;

    /**
     * 网考-用于环境监测的考生ID
     */
    Long OE_ENV_CHECK_EXAM_STUDENT_ID = 0L;

    /**
     * 分数及格线（整数百分比）默认：60%
     */
    int OE_PASSS_CORE_LINE = 60;

    /**
     * 分数优秀线（整数百分比）默认：90%
     */
    int OE_GOOD_SCORE_LINE = 90;

}
