package cn.com.qmth.examcloud.support.enums;

/**
 * 考试记录状态
 *
 * @author xudengqi
 * 2016年8月23日
 */
public enum ExamRecordStatus {
    /**
     * 考试中
     */
    EXAM_ING,
    /**
     * 手工交卷处理中
     */
    EXAM_HAND_IN,
    /**
     * 系统交卷处理中
     */
    EXAM_AUTO_HAND_IN,
    /**
     * 考试结束
     */
    EXAM_END,

    /**
     * 考试过期
     */
    EXAM_OVERDUE,

    /**
     * 考试无效/作废
     */
    EXAM_INVALID,

    /**
     * 考试异常数据
     */
    EXAM_ERROR;

    public static ExamRecordStatus getByName(String name) {
        for (ExamRecordStatus status : values()) {
            if (status.name().equals(name)) {
                return status;
            }
        }
        return null;
    }

}