package cn.com.qmth.examcloud.support.enums;

/**
 * @Description 活体检测方案枚举
 * @Author lideyin
 * @Date 2019/11/6 15:03
 * @Version 1.0
 */
public enum FaceBiopsyScheme {

    /**
     * FaceID活体检测方案(即旧活体检测方案)
     */
    FACE_ID("S1", "FaceID活体检测方案"),

    /**
     * Electron Client 自研活体检测方案
     */
    FACE_MOTION("S2", "自研活体检测方案"),

    /**
     * C端活体检测方案
     */
    FACE_CLIENT("S3", "C端活体检测方案");

    private String code;

    private String desc;

    FaceBiopsyScheme(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    /**
     * 获取活检方案代码
     */
    public String getCode() {
        return this.code;
    }

    /**
     * 获取活检方案描述
     */
    public String getDesc() {
        return this.desc;
    }

}
