package cn.com.qmth.examcloud.starters.crypto;

import cn.com.qmth.examcloud.starters.crypto.service.CryptoFactory;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
@EnableConfigurationProperties(CryptoProperties.class)
public class CryptoAutoConfiguration {

    private static final Logger log = LoggerFactory.getLogger(CryptoAutoConfiguration.class);

    @Bean
    public CryptoFactory cryptoFactory() {
        log.info("cryptoFactory init...");
        return new CryptoFactory();
    }

}
