package cn.com.qmth.examcloud.starters.crypto;

import org.springframework.boot.context.properties.ConfigurationProperties;

import java.io.Serializable;

/**
 * 加、解密算法配置类
 */
@ConfigurationProperties(prefix = "examcloud.starters.crypto", ignoreUnknownFields = false)
public class CryptoProperties implements Serializable {

    private static final long serialVersionUID = 1L;

    private String rsaPublicKey;

    private String rsaPrivateKey;

    /**
     * 默认加密方案组合
     */
    private String[] groups;

    public String getRsaPublicKey() {
        return rsaPublicKey;
    }

    public void setRsaPublicKey(String rsaPublicKey) {
        this.rsaPublicKey = rsaPublicKey;
    }

    public String getRsaPrivateKey() {
        return rsaPrivateKey;
    }

    public void setRsaPrivateKey(String rsaPrivateKey) {
        this.rsaPrivateKey = rsaPrivateKey;
    }

    public String[] getGroups() {
        return groups;
    }

    public void setGroups(String[] groups) {
        this.groups = groups;
    }

}
