package cn.com.qmth.examcloud.starters.crypto.common;

import cn.com.qmth.examcloud.starters.crypto.service.impl.*;

/**
 * 加、解密算法类型
 */
public enum CryptoType {

    A(AesCryptoService.class, Algorithm.AES),

    B(Base64CryptoService.class, Algorithm.BASE64),

    C(Rc4CryptoService.class, Algorithm.RC4),

    D(DesCryptoService.class, Algorithm.DES),

    E(TripleDesCryptoService.class, Algorithm.TRIPLE_DES);

    // RSA存在性能问题暂停使用
    // R(RsaCryptoService.class, Algorithm.RSA);

    private Class impl;

    private Algorithm algorithm;

    CryptoType(Class impl, Algorithm algorithm) {
        this.impl = impl;
        this.algorithm = algorithm;
    }

    public static CryptoType findByName(String name) {
        for (CryptoType type : values()) {
            if (type.name().equals(name)) {
                return type;
            }
        }
        return null;
    }

    public Class getImpl() {
        return impl;
    }

    public Algorithm getAlgorithm() {
        return algorithm;
    }

}
