package cn.com.qmth.examcloud.starters.crypto.service.impl;

import cn.com.qmth.examcloud.starters.crypto.common.Key;
import cn.com.qmth.examcloud.starters.crypto.service.CryptoService;
import org.apache.commons.codec.binary.Base64;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.nio.charset.StandardCharsets;

/**
 * BASE64算法
 */
public class Base64CryptoService implements CryptoService {

    private static final Logger log = LoggerFactory.getLogger(Base64CryptoService.class);

    @Override
    public String encrypt(String str, Key key) {
        byte[] bytes = str.getBytes(StandardCharsets.UTF_8);
        return Base64.encodeBase64String(bytes);
    }

    @Override
    public String decrypt(String str, Key key) {
        byte[] bytes = Base64.decodeBase64(str);
        return new String(bytes, StandardCharsets.UTF_8);
    }

}
