package cn.com.qmth.examcloud.starters.crypto.service.impl;

import cn.com.qmth.examcloud.starters.crypto.common.CryptoConstant;
import cn.com.qmth.examcloud.starters.crypto.common.CryptoException;
import cn.com.qmth.examcloud.starters.crypto.common.Key;
import cn.com.qmth.examcloud.starters.crypto.service.CryptoService;
import cn.com.qmth.examcloud.starters.crypto.utils.Rc4Util;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * RC4算法
 */
public class Rc4CryptoService implements CryptoService {

    private static final Logger log = LoggerFactory.getLogger(Rc4CryptoService.class);

    @Override
    public String encrypt(String str, Key key) {
        if (key == null || StringUtils.isEmpty(key.getValue())) {
            throw new CryptoException(CryptoConstant.KEY_ERROR);
        }

        return Rc4Util.encrypt(str, key.getValue());
    }

    @Override
    public String decrypt(String str, Key key) {
        if (key == null || StringUtils.isEmpty(key.getValue())) {
            throw new CryptoException(CryptoConstant.KEY_ERROR);
        }

        return Rc4Util.decrypt(str, key.getValue());
    }

}
