package cn.com.qmth.examcloud.starters.face.verify;

import cn.com.qmth.examcloud.starters.face.verify.service.FaceVerifyService;
import cn.com.qmth.examcloud.starters.face.verify.service.impl.FaceVerifyServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
@EnableConfigurationProperties(FaceVerifyProperties.class)
public class FaceVerifyAutoConfiguration {

    private final static Logger log = LoggerFactory.getLogger(FaceVerifyAutoConfiguration.class);

    @Bean
    public FaceVerifyService faceVerifyService(FaceVerifyProperties faceVerifyProperties) {
        log.info("faceVerifyService init...");
        FaceVerifyServiceImpl impl = new FaceVerifyServiceImpl();
        impl.setProperties(faceVerifyProperties);
        return impl;
    }

}
