package cn.com.qmth.examcloud.starters.face.verify;

import org.springframework.boot.context.properties.ConfigurationProperties;

import java.io.Serializable;

/**
 * 人脸识别相关配置信息
 */
@ConfigurationProperties(prefix = "examcloud.starters.face.verify", ignoreUnknownFields = false)
public class FaceVerifyProperties implements Serializable {

    private static final long serialVersionUID = 1L;

    /*
     * Face++ API Key
     */
    private String facePlusKey;

    /*
     * Face++ API Secret
     */
    private String facePlusSecret;

    /*
     * 百度 API Key
     */
    private String baiduKey;

    /*
     * 百度 API Secret
     */
    private String baiduSecret;

    /*
     * 百度 私有化部署 是否启用
     */
    private Boolean baiduLocalEnabled = false;

    /*
     * 百度 私有化部署 appId
     */
    private String baiduLocalAppId;

    /*
     * 百度 私有化部署 接口地址前缀
     */
    private String baiduLocalUrlPrefix;

    /*
     * 百度 人脸相似度得分（自定义期望通过阈值）
     */
    private Double baiduExpectFaceCompareScore = 70d;

    public String getFacePlusKey() {
        return facePlusKey;
    }

    public void setFacePlusKey(String facePlusKey) {
        this.facePlusKey = facePlusKey;
    }

    public String getFacePlusSecret() {
        return facePlusSecret;
    }

    public void setFacePlusSecret(String facePlusSecret) {
        this.facePlusSecret = facePlusSecret;
    }

    public String getBaiduKey() {
        return baiduKey;
    }

    public void setBaiduKey(String baiduKey) {
        this.baiduKey = baiduKey;
    }

    public String getBaiduSecret() {
        return baiduSecret;
    }

    public void setBaiduSecret(String baiduSecret) {
        this.baiduSecret = baiduSecret;
    }

    public Boolean getBaiduLocalEnabled() {
        return baiduLocalEnabled;
    }

    public void setBaiduLocalEnabled(Boolean baiduLocalEnabled) {
        this.baiduLocalEnabled = baiduLocalEnabled;
    }

    public String getBaiduLocalAppId() {
        return baiduLocalAppId;
    }

    public void setBaiduLocalAppId(String baiduLocalAppId) {
        this.baiduLocalAppId = baiduLocalAppId;
    }

    public String getBaiduLocalUrlPrefix() {
        return baiduLocalUrlPrefix;
    }

    public void setBaiduLocalUrlPrefix(String baiduLocalUrlPrefix) {
        this.baiduLocalUrlPrefix = baiduLocalUrlPrefix;
    }

    public Double getBaiduExpectFaceCompareScore() {
        return baiduExpectFaceCompareScore;
    }

    public void setBaiduExpectFaceCompareScore(Double baiduExpectFaceCompareScore) {
        this.baiduExpectFaceCompareScore = baiduExpectFaceCompareScore;
    }

}
