package cn.com.qmth.examcloud.starters.face.verify.model;

import java.io.Serializable;

/**
 * 人脸相关接口（通用）响应结果
 */
public class FaceResult implements Serializable {

    private static final long serialVersionUID = -6981807543872661368L;

    /**
     * 接口是否需要重试
     * 注：接口请求出现网络、图片加载等偶发异常时建议重试几次调用，其它情况则终止处理！
     */
    private boolean apiNeedRetry;

    /**
     * 人脸是否通过
     */
    private boolean facePass;

    /**
     * 人脸分值
     */
    private double faceScore;

    /**
     * 人脸数
     */
    private int faceNum;

    /**
     * 人脸接口响应信息
     */
    private String jsonResult;

    /**
     * 错误信息
     */
    private String error;

    /**
     * 是否存在陌生人
     */
    public boolean hasStranger() {
        return faceNum > 1;
    }

    public boolean isApiNeedRetry() {
        return apiNeedRetry;
    }

    public void setApiNeedRetry(boolean apiNeedRetry) {
        this.apiNeedRetry = apiNeedRetry;
    }

    public boolean isFacePass() {
        return facePass;
    }

    public void setFacePass(boolean facePass) {
        this.facePass = facePass;
    }

    public double getFaceScore() {
        return faceScore;
    }

    public void setFaceScore(double faceScore) {
        this.faceScore = faceScore;
    }

    public int getFaceNum() {
        return faceNum;
    }

    public void setFaceNum(int faceNum) {
        this.faceNum = faceNum;
    }

    public String getJsonResult() {
        return jsonResult;
    }

    public void setJsonResult(String jsonResult) {
        this.jsonResult = jsonResult;
    }

    public String getError() {
        return error;
    }

    public void setError(String error) {
        this.error = error;
    }

}
