package cn.com.qmth.examcloud.starters.face.verify.service;

import cn.com.qmth.examcloud.starters.face.verify.model.FaceResult;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageParm;

public interface FaceVerifyService {

    /**
     * 百度 人脸活体检测（不支持陌生人检测）
     */
    FaceResult faceVerifyByBaidu(ImageParm image);

    /**
     * 百度 人脸检测（支持陌生人检测）
     */
    FaceResult faceDetectByBaidu(ImageParm image);

    /**
     * 百度 人脸比对（不支持陌生人检测）
     */
    FaceResult faceCompareByBaidu(ImageParm image1, ImageParm image2);

    /**
     * 百度 人脸比对（不支持陌生人检测）
     *
     * @param expectFaceCompareScore 自定义期望通过阈值
     */
    FaceResult faceCompareByBaidu(ImageParm image1, ImageParm image2, Double expectFaceCompareScore);

    /**
     * Face++ 人脸检测（支持陌生人检测）
     */
    FaceResult faceDetectByFacePlus(ImageParm image);

    /**
     * Face++ 人脸比对（支持陌生人检测）
     */
    FaceResult faceCompareByFacePlus(ImageParm image1, ImageParm image2);

}
