package cn.com.qmth.examcloud.starters.face.verify.test;

import cn.com.qmth.examcloud.starters.face.verify.FaceVerifyProperties;
import cn.com.qmth.examcloud.starters.face.verify.common.JsonHelper;
import cn.com.qmth.examcloud.starters.face.verify.model.FaceResult;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageFileParm;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageParm;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageTokenParm;
import cn.com.qmth.examcloud.starters.face.verify.model.param.ImageUrlParm;
import cn.com.qmth.examcloud.starters.face.verify.service.impl.FaceVerifyServiceImpl;
import org.junit.Test;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class FaceApiTest {

    // @Test
    public void demo() throws Exception {
        FaceVerifyProperties properties = new FaceVerifyProperties();
        properties.setFacePlusKey("xxx");
        properties.setFacePlusSecret("xxx");
        properties.setBaiduKey("xxx");
        properties.setBaiduSecret("xxx");
        properties.setBaiduLocalEnabled(true);
        properties.setBaiduLocalAppId("test");
        properties.setBaiduLocalUrlPrefix("http://192.168.20.253");
        // properties.setBaiduLocalUrlPrefix("http://192.168.0.118");
        // properties.setBaiduExpectFaceCompareScore(70d);

        FaceVerifyServiceImpl faceVerifyService = new FaceVerifyServiceImpl();
        faceVerifyService.setProperties(properties);

        String image1 = "https://ecs-test-static.qmth.com.cn//capture_photo/temp/001.jpg";
        String image2 = "https://ecs-test-static.qmth.com.cn//capture_photo/temp/002.jpg";
        String image3 = "https://ecs-test-static.qmth.com.cn//capture_photo/temp/003.jpg";
        String image4 = "https://ecs-test-static.qmth.com.cn//capture_photo/temp/004.jpg";
        String image5 = "https://ecs-test-static.qmth.com.cn//capture_photo/temp/005.jpg";
        String image6 = "https://ecs-test-static.qmth.com.cn//capture_photo/temp/006.jpg";
        String image7 = "D:\\home\\test\\101.jpg";
        String image8 = "D:\\home\\test\\102.jpg";
        String image9 = "8754a4180b540110a110fbfa9f0aec18";
        String image10 = "91f67a6eb2c58482aad08aeec58b9ef4";

        ImageParm imageParm1 = new ImageUrlParm(image1);
        ImageParm imageParm2 = new ImageUrlParm(image6);
        ImageParm imageParm7 = new ImageFileParm(image7);
        ImageParm imageParm8 = new ImageFileParm(image8);
        ImageParm imageParm9 = new ImageTokenParm(image9);
        ImageParm imageParm10 = new ImageTokenParm(image10);

        FaceResult result = faceVerifyService.faceVerifyByBaidu(imageParm1);
        // FaceResult result = faceVerifyService.faceDetectByBaidu(imageParm1);
        // FaceResult result = faceVerifyService.faceCompareByBaidu(imageParm1, imageParm2);
        // FaceResult result = faceVerifyService.faceDetectByFacePlus(imageParm1);
        // FaceResult result = faceVerifyService.faceCompareByFacePlus(imageParm1, imageParm2);
        System.out.println("==================================================");
        System.out.println(new JsonHelper().toJson(result));

        // concurrentTest(faceVerifyService, imageParm);
    }

    private void concurrentTest(FaceVerifyServiceImpl faceVerifyService, ImageParm image) {
        int threadNum = 20;
        ExecutorService service = Executors.newCachedThreadPool();
        final CountDownLatch commander = new CountDownLatch(1);
        final CountDownLatch worker = new CountDownLatch(threadNum);

        for (int n = 0; n < threadNum; n++) {
            Runnable runnable = () -> {
                try {
                    FaceResult res = faceVerifyService.faceVerifyByBaidu(image);
                    System.out.println("线程：" + Thread.currentThread().getName() + " 结果：" + new JsonHelper().toJson(res) + "\n");
                } catch (Exception e) {
                    e.printStackTrace();
                } finally {
                    worker.countDown();
                }
            };
            service.execute(runnable);
        }

        try {
            commander.countDown();
            worker.await();
        } catch (Exception e) {
            e.printStackTrace();
        }

        service.shutdown();
    }

}
