/*
 * Copyright (c) 2020 QMTH All Rights Reserved.
 * Created by Deason on 2020-07-22 16:19:27
 */

package cn.com.qmth.examcloud.starters.greetest;

import cn.com.qmth.examcloud.starters.greetest.service.GeetestService;
import cn.com.qmth.examcloud.starters.greetest.service.GeetestSessionManager;
import cn.com.qmth.examcloud.starters.greetest.service.impl.GeetestServiceImpl;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
@EnableConfigurationProperties(GeetestProperties.class)
public class GeetestAutoConfiguration {

    private static final Logger LOG = LoggerFactory.getLogger(GeetestAutoConfiguration.class);

    @Bean
    public GeetestService geetestService(@Autowired GeetestProperties properties, @Autowired GeetestSessionManager sessionManager) {
        LOG.info("geetestService init...");

        GeetestServiceImpl impl = new GeetestServiceImpl();
        impl.setProperties(properties);
        impl.setSessionManager(sessionManager);
        return impl;
    }

}
