/*
 * Copyright (c) 2020 QMTH All Rights Reserved.
 * Created by Deason on 2020-07-22 16:19:27
 */

package cn.com.qmth.examcloud.starters.greetest;

import org.springframework.boot.context.properties.ConfigurationProperties;

import java.io.Serializable;

@ConfigurationProperties(prefix = "examcloud.starters.geetest", ignoreUnknownFields = false)
public class GeetestProperties implements Serializable {

    private static final long serialVersionUID = 1L;

    /**
     * 极验-接口地址
     */
    private String apiUrl;

    /**
     * 极验-公钥
     */
    private String id;

    /**
     * 极验-私钥
     */
    private String key;

    /**
     * 极验-客户端类型
     * 默认值：web
     */
    private String client_type = "web";

    /**
     * 极验-字符串的签名算法
     * 默认值：md5
     */
    private String digestmod = "md5";

    /**
     * 极验-json格式化标识
     * 默认值：1
     */
    private String json_format = "1";

    /**
     * 极验-sdk代码版本号
     * 默认值：jave-servlet:3.1.0
     */
    private String sdk = "jave-servlet:3.1.0";

    public String getApiUrl() {
        return apiUrl;
    }

    public void setApiUrl(String apiUrl) {
        this.apiUrl = apiUrl;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getKey() {
        return key;
    }

    public void setKey(String key) {
        this.key = key;
    }

    public String getClient_type() {
        return client_type;
    }

    public void setClient_type(String client_type) {
        this.client_type = client_type;
    }

    public String getDigestmod() {
        return digestmod;
    }

    public void setDigestmod(String digestmod) {
        this.digestmod = digestmod;
    }

    public String getJson_format() {
        return json_format;
    }

    public void setJson_format(String json_format) {
        this.json_format = json_format;
    }

    public String getSdk() {
        return sdk;
    }

    public void setSdk(String sdk) {
        this.sdk = sdk;
    }

}