/*
 * Copyright (c) 2020 QMTH All Rights Reserved.
 * Created by Deason on 2020-07-22 16:19:27
 */

package cn.com.qmth.examcloud.starters.greetest.model;

import io.swagger.annotations.ApiModelProperty;

public class RegisterReq implements IModel {

    private static final long serialVersionUID = 1L;

    /**
     * 作为终端用户的唯一标识，确定用户的唯一性；
     * 作用于提供进阶数据分析服务，可在api1 或 api2 接口传入，不传入也不影响验证服务的使用；
     * 若担心用户信息风险，可作预处理(如哈希处理)再提供到极验
     */
    @ApiModelProperty(value = "账号唯一标识", required = true)
    protected String user_id;

    /**
     * 客户端类型，web（pc浏览器），h5（手机浏览器，包括webview），native（原生app），unknown（未知）
     */
    @ApiModelProperty(value = "客户端类型（选填）")
    protected String client_type;

    /**
     * 客户端请求SDK服务器的ip地址
     */
    @ApiModelProperty(hidden = true)
    protected String ip_address;

    public String getUser_id() {
        return user_id;
    }

    public void setUser_id(String user_id) {
        this.user_id = user_id;
    }

    public String getClient_type() {
        return client_type;
    }

    public void setClient_type(String client_type) {
        this.client_type = client_type;
    }

    public String getIp_address() {
        return ip_address;
    }

    public void setIp_address(String ip_address) {
        this.ip_address = ip_address;
    }

}
