/*
 * Copyright (c) 2020 QMTH All Rights Reserved.
 * Created by Deason on 2020-07-22 16:19:27
 */

package cn.com.qmth.examcloud.starters.greetest.model;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

public class RegisterResp implements IModel {

    private static final long serialVersionUID = 1L;

    /**
     * 流程正常、异常标识；true表示正常，false表示异常、后续走宕机模式
     */
    protected Boolean success;

    /**
     * 结果提示信息
     */
    protected String msg;

    /**
     * 生成唯一流水号的参考字符串，为”0”表示传参账号id有误
     */
    private String challenge;

    /**
     * 新版验证码标识，固定不变
     */
    private Boolean new_captcha;

    /**
     * 向极验申请的账号id
     */
    private String gt;

    public RegisterResp(Boolean success, String msg) {
        this.success = success;
        this.msg = msg;
    }

    public RegisterResp() {

    }

    public Boolean getSuccess() {
        return success;
    }

    public void setSuccess(Boolean success) {
        this.success = success;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public String getChallenge() {
        return challenge;
    }

    public void setChallenge(String challenge) {
        this.challenge = challenge;
    }

    public Boolean getNew_captcha() {
        return new_captcha;
    }

    public void setNew_captcha(Boolean new_captcha) {
        this.new_captcha = new_captcha;
    }

    public String getGt() {
        return gt;
    }

    public void setGt(String gt) {
        this.gt = gt;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.JSON_STYLE);
    }

}
