/*
 * Copyright (c) 2020 QMTH All Rights Reserved.
 * Created by Deason on 2020-07-22 16:19:27
 */

package cn.com.qmth.examcloud.starters.greetest.model;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

public class ValidateResp implements IModel {

    private static final long serialVersionUID = 1L;

    /**
     * 流程正常、异常标识；true表示正常，false表示异常、后续走宕机模式
     */
    protected Boolean success;

    /**
     * 结果提示信息
     */
    protected String msg;

    /**
     * 服务端sdk版本
     */
    private String version;

    public ValidateResp(Boolean success, String msg) {
        this.success = success;
        this.msg = msg;
    }

    public ValidateResp() {

    }

    public Boolean getSuccess() {
        return success;
    }

    public void setSuccess(Boolean success) {
        this.success = success;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.JSON_STYLE);
    }

}