package cn.com.qmth.examcloud.commons.helpers;

import java.util.concurrent.atomic.AtomicLong;

/**
 * 计数器
 *
 * @author WANGWEI
 * @date 2018年1月26日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 */
public class Counter {

    private AtomicLong counter;

    /**
     * 最小值
     */
    private long min;

    /**
     * 最大值
     */
    private long max;

    /**
     * 循环计数回合数
     */
    private int bout = 0;

    /**
     * 构造函数
     *
     * @param min
     * @param max
     */
    public Counter(long min, long max) {
        this.min = min;
        this.max = max;
        bout();
    }

    /**
     * 初始化循环
     *
     * @author WANGWEI
     */
    private void bout() {
        int cur = bout;
        synchronized (this) {
            if (cur < bout) {
                return;
            }
            counter = new AtomicLong(min);
            bout++;
        }
    }

    /**
     * 方法注释
     *
     * @return
     * @author WANGWEI
     */
    public long next() {
        long next = counter.getAndIncrement();

        if (next > max) {
            bout();
            return next();
        }

        return next;
    }

    public long get() {
        return counter.get();
    }

}
