package cn.com.qmth.examcloud.commons.helpers;

import com.thoughtworks.xstream.XStream;
import com.thoughtworks.xstream.converters.basic.DateConverter;
import com.thoughtworks.xstream.converters.basic.DoubleConverter;
import com.thoughtworks.xstream.converters.basic.FloatConverter;

import java.util.TimeZone;

/**
 * 类注释
 *
 * @author WANGWEI
 */
public class XStreamBuilder {

    /**
     * 属性注释
     */
    private XStream xs;

    /**
     * 构造函数
     */
    private XStreamBuilder() {
        this.xs = new XStream();
        XStream.setupDefaultSecurity(this.xs);
    }

    /**
     * 方法注释
     *
     * @return
     * @author WANGWEI
     */
    public static XStreamBuilder newInstance() {
        XStreamBuilder builder = new XStreamBuilder();
        return builder;
    }

    /**
     * 方法注释
     *
     * @param defaultFormat
     * @return
     * @author WANGWEI
     */
    public XStreamBuilder registerDateConverter(final String defaultFormat) {
        xs.registerConverter(new DateConverter(defaultFormat, null, TimeZone.getTimeZone("GMT+8")));
        return this;
    }

    /**
     * 方法注释
     *
     * @return
     * @author WANGWEI
     */
    public XStreamBuilder registerNormalNumberConverter() {
        xs.registerConverter(new NormalDoubleConverter());
        xs.registerConverter(new NormalFloatConverter());
        return this;
    }

    /**
     * 类注释
     *
     * @author WANGWEI
     */
    private class NormalDoubleConverter extends DoubleConverter {

        public String toString(Object obj) {
            return String.valueOf(obj);
        }

    }

    /**
     * 类注释
     *
     * @author WANGWEI
     */
    private class NormalFloatConverter extends FloatConverter {

        public String toString(Object obj) {
            return String.valueOf(obj);
        }

    }

    /**
     * 方法注释
     *
     * @return
     * @author WANGWEI
     */
    public XStream build() {
        return xs;
    }

}