package cn.com.qmth.examcloud.commons.helpers.pipeline;

import java.util.concurrent.atomic.AtomicLong;

/**
 * 输出计数器
 *
 * @author WANGWEI
 * @date 2019年12月12日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 */
public class Counter {

    private AtomicLong total = new AtomicLong(0);

    private AtomicLong successAmount = new AtomicLong(0);

    private AtomicLong failureAmount = new AtomicLong(0);

    public long getTotal() {
        return total.get();
    }

    public long getSuccessAmount() {
        return successAmount.get();
    }

    public long getFailureAmount() {
        return failureAmount.get();
    }

    public long incrementTotal() {
        return this.total.incrementAndGet();
    }

    public long incrementSuccessAmount() {
        return this.successAmount.incrementAndGet();
    }

    public long incrementFailureAmount() {
        return this.failureAmount.incrementAndGet();
    }

}