package cn.com.qmth.examcloud.commons.helpers.pipeline;

import cn.com.qmth.examcloud.commons.helpers.KeyValuePair;
import cn.com.qmth.examcloud.commons.helpers.ObjectHolder;

import java.util.List;

/**
 * 节点执行器
 *
 * @param <KEYIN>
 * @param <VALUEIN>
 * @param <KEYOUT>
 * @param <VALUEOUT>
 * @author WANGWEI
 * @date 2019年12月12日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 */
public interface NodeExecuter<KEYIN, VALUEIN, KEYOUT, VALUEOUT> {

    /**
     * 执行
     *
     * @param key
     * @param value
     * @param outList
     * @param removable
     * @param context
     * @throws Exception
     * @author WANGWEI
     */
    void execute(KEYIN key, VALUEIN value, final List<KeyValuePair<KEYOUT, VALUEOUT>> outList,
                 final ObjectHolder<Boolean> removable, TaskContext context) throws Exception;

}