package cn.com.qmth.examcloud.commons.helpers.pipeline;

import java.io.Serializable;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * 任务上下文(任务参数)
 *
 * @author WANGWEI
 * @date 2019年12月12日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 */
public class TaskContext implements Serializable {

    private static final long serialVersionUID = 4979254175922604943L;

    private final Map<String, Object> props = new ConcurrentHashMap<String, Object>();

    public String get(String name) {
        return get(name, String.class);
    }

    public <T> T get(String name, Class<T> t) {
        Object value = props.get(name);
        @SuppressWarnings("unchecked")
        T ret = (T) value;
        return ret;
    }

    public void put(String name, Object bean) {
        props.put(name, bean);
    }

}