package cn.com.qmth.examcloud.commons.util;

import cn.com.qmth.examcloud.commons.exception.ExamCloudRuntimeException;
import freemarker.template.Configuration;
import freemarker.template.Template;

import java.io.StringReader;
import java.io.StringWriter;
import java.util.Locale;

/**
 * FreeMarker 工具
 *
 * @author WANGWEI
 * @date 2018年11月21日
 * @Copyright (c) 2018-2020 http://www.qmth.com.cn/ All Rights Reserved.
 */
public class FreeMarkerUtil {

    private static final String ENCODING = "UTF-8";

    private static Configuration configuration;

    static {
        configuration = new Configuration(Configuration.VERSION_2_3_23);
        configuration.setEncoding(Locale.US, ENCODING);
    }

    /**
     * 方法注释
     *
     * @param template
     * @param dataModel
     * @return
     * @author WANGWEI
     */
    public static String process(String template, Object dataModel) {
        return process("$$$$$", template, dataModel);
    }

    /**
     * 方法注释
     *
     * @param name
     * @param template
     * @param dataModel
     * @return
     * @author WANGWEI
     */
    public static String process(String name, String template, Object dataModel) {
        StringWriter result = null;
        try {
            result = new StringWriter();
            Template t = new Template(name, new StringReader(template), configuration);
            t.process(dataModel, result);

            return result.toString();
        } catch (Exception e) {
            throw new ExamCloudRuntimeException(e);
        }
    }

}
