package cn.com.qmth.examcloud.support.examing;

import cn.com.qmth.examcloud.api.commons.exchange.JsonSerializable;

import java.util.List;

/**
 * 考试控制属性<br>
 * ExamBoss存储于redis,无过期时间<br>
 * 开考时,startCount++<br>
 * 数据从student同步至admin后,endCount++<br>
 * startCount== endCount 时,清理 {@link ExamBoss}
 *
 * @author WANGWEI
 * @date 2019年12月16日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class ExamBoss implements JsonSerializable {

    private static final long serialVersionUID = -3499412275759440367L;

    /**
     * 开考次数
     */
    private int startCount;

    /**
     * 完结次数
     */
    private int endCount;

    /**
     * 未同步的考试记录id
     */
    private List<Long> examRecordDataIds;

    public int getStartCount() {
        return startCount;
    }

    public void setStartCount(int startCount) {
        this.startCount = startCount;
    }

    public int getEndCount() {
        return endCount;
    }

    public void setEndCount(int endCount) {
        this.endCount = endCount;
    }


    public List<Long> getExamRecordDataIds() {
        return examRecordDataIds;
    }


    public void setExamRecordDataIds(List<Long> examRecordDataIds) {
        this.examRecordDataIds = examRecordDataIds;
    }

}
