package cn.com.qmth.examcloud.support.examing;

import cn.com.qmth.examcloud.api.commons.exchange.JsonSerializable;
import cn.com.qmth.examcloud.support.enums.FileAnswerAcknowledgeStatus;

/**
 * @Description 文件作答记录（考完则清理）
 * @Author lideyin
 * @Date 2019/12/13 16:22
 * @Version 1.0
 */
public class ExamFileAnswer implements JsonSerializable {

    private static final long serialVersionUID = -7441792839367736076L;

    /**
     * 主键id
     */
    private Long id;

    /**
     * 考试记录id
     */
    private Long examRecordDataId;

    /**
     * 考生id
     */
    private Long examStudentId;

    /**
     * 小题序号
     */
    private Integer questionOrder;

    /**
     * 文件路径
     */
    private String filePath;

    /**
     * 文件作答的响应状态
     */
    private FileAnswerAcknowledgeStatus status;

    /**
     * 传输文件的类型（PIC | AUDIO）
     */
    private String transferFileType;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Long getExamRecordDataId() {
        return examRecordDataId;
    }

    public void setExamRecordDataId(Long examRecordDataId) {
        this.examRecordDataId = examRecordDataId;
    }

    public Long getExamStudentId() {
        return examStudentId;
    }

    public void setExamStudentId(Long examStudentId) {
        this.examStudentId = examStudentId;
    }


    public Integer getQuestionOrder() {
        return questionOrder;
    }

    public void setQuestionOrder(Integer questionOrder) {
        this.questionOrder = questionOrder;
    }

    public String getFilePath() {
        return filePath;
    }

    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }

    public FileAnswerAcknowledgeStatus getStatus() {
        return status;
    }

    public void setStatus(FileAnswerAcknowledgeStatus status) {
        this.status = status;
    }

    public String getTransferFileType() {
        return transferFileType;
    }

    public void setTransferFileType(String transferFileType) {
        this.transferFileType = transferFileType;
    }

}
