package cn.com.qmth.examcloud.support.filestorage;

import io.swagger.annotations.ApiModelProperty;

import java.io.Serializable;

/**
 * 文件上传结果
 */
public class UploadResult implements Serializable {

    private static final long serialVersionUID = -4133740797472293134L;

    @ApiModelProperty(value = "文件名")
    private String fileName;

    @ApiModelProperty(value = "文件存储地址")
    private String filePath;

    @ApiModelProperty(value = "文件访问地址")
    private String fileUrl;

    public UploadResult(String fileName, String filePath, String fileUrl) {
        this.fileName = fileName;
        this.filePath = filePath;
        this.fileUrl = fileUrl;
    }

    public UploadResult(String filePath, String fileUrl) {
        this.filePath = filePath;
        this.fileUrl = fileUrl;
    }

    public UploadResult() {

    }

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public String getFilePath() {
        return filePath;
    }

    public void setFilePath(String filePath) {
        this.filePath = filePath;
    }

    public String getFileUrl() {
        return fileUrl;
    }

    public void setFileUrl(String fileUrl) {
        this.fileUrl = fileUrl;
    }

}
