package cn.com.qmth.examcloud.support.handler.richtext2;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

/**
 * 段落
 */
public class Section implements Serializable {

    private static final long serialVersionUID = -8820818435363871114L;

    private List<Block> blocks;

    public void addBlock(Block block) {
        if (block == null) {
            return;
        }
        if (blocks == null) {
            blocks = new ArrayList<>();
        }
        blocks.add(block);
    }

    public List<Block> getBlocks() {
        if (blocks == null) {
            blocks = new ArrayList<>();
        }
        return blocks;
    }

    public void setBlocks(List<Block> blocks) {
        this.blocks = blocks;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this, ToStringStyle.JSON_STYLE);
    }

}
