package cn.com.qmth.examcloud.support.privilege;

/**
 * 权限定义<br>
 * 一个接口代表一个权限组或权限<br>
 * CODE为权限组编码或权限编码 <br>
 * <{@link PrivilegeDefine}内部第一级接口必须为权限组<br>
 * 权限组下以树形结构定义权限<br>
 *
 * @author WANGWEI
 * @date 2019年7月10日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface PrivilegeDefine {

    // 数据访问权限组
    public interface DataAccess {

        String CODE = "DATA_ACCESS";

        // 网考数据访问权限
        public interface OnlineExamData {

            String CODE = "ONLINE_EXAM_DATA";

            // 违纪名单数据权限
            public interface DataViolatingDiscipline {

                String CODE = "DATA_VIOLATING_DISCIPLINE";

                // 未通过审核的学生照片权限
                public interface UnapprovedStudentPhoto {

                    String CODE = "UNAPPROVED_STUDENT_PHOTO";

                }

                // 所有学生照片权限
                public interface AllStudentPhoto {

                    String CODE = "ALL_STUDENT_PHOTO";

                }

            }

        }

        // 考务数据访问权限
        public interface ExamWorkData {

            String CODE = "EXAM_WORK_DATA";

            // 学生数据
            public interface StudentInfoData {

                String CODE = "STUDENT_INFO_DATA";

                // 学习中心学生数据
                public interface OrgStudentData {

                    String CODE = "ORG_STUDENT_DATA";

                }

                // 所有学生数据
                public interface AllStudentData {

                    String CODE = "ALL_STUDENT_DATA";

                }

            }

        }

    }

    // 顶级机构功能权限组
    public interface RootOrgFunctions {

        String CODE = "ROOT_ORG_FUNCTIONS";

        // 网考功能
        public interface OnlineExamFunctions {

            String CODE = "ONLINE_EXAM_FUNCTIONS";

            // 人脸识别
            public interface FaceCheck {

                String CODE = "FACE_CHECK";

            }

            // 活体检测
            public interface IdentificationOfLivingBody {

                String CODE = "IDENTIFICATION_OF_LIVING_BODY";

            }

        }

    }

}
