package cn.com.qmth.examcloud.support.redis;

import cn.com.qmth.examcloud.support.CacheConstants;

/**
 * Redis key构建器接口
 *
 * @author WANGWEI
 * @date 2019年8月16日
 */
public interface RedisKeyBuilder {

    @RedisKeyDefine(value = "网考考试会话", Prefix = CacheConstants.CACHE_OE_SESSION)
    String examingSessionKey(Long studentId);

    @RedisKeyDefine(value = "考试次数控制", Prefix = CacheConstants.CACHE_OE_BOSS)
    String examBossKey(Long examStudentId);

    @RedisKeyDefine(value = "网考考试记录", Prefix = CacheConstants.CACHE_OE_RECORD)
    String examRecordDataKey(Long examRecordDataId);

    @RedisKeyDefine(value = "考试心跳", Prefix = CacheConstants.CACHE_OE_HEARTBEAT)
    String examingHeartbeatKey(Long examRecordDataId);

    @RedisKeyDefine(value = "考试活动时间", Prefix = CacheConstants.CACHE_OE_ACTIVE)
    String examingActiveTimeKey(Long examRecordDataId);

    @RedisKeyDefine(value = "网考试卷结构", Prefix = CacheConstants.CACHE_OE_PAPER)
    String studentPaperKey(Long examRecordDataId);

    @RedisKeyDefine(value = "网考作答", Prefix = CacheConstants.CACHE_OE_ANSWER)
    String studentAnswerKey(Long examRecordDataId, Integer order);

    @RedisKeyDefine(value = "网考文件作答", Prefix = CacheConstants.CACHE_OE_FILE_ANSWER)
    String studentFileAnswerKey(Long examRecordDataId, Integer order);

}
