package cn.com.qmth.examcloud.web.bootstrap;

import cn.com.qmth.examcloud.commons.exception.ExamCloudRuntimeException;
import cn.com.qmth.examcloud.commons.util.AES;
import com.google.common.collect.Maps;
import com.google.common.collect.Sets;

import java.util.Map;
import java.util.Map.Entry;
import java.util.Properties;
import java.util.Set;

/**
 * 安全工具
 *
 * @author WANGWEI
 * @date 2018年12月4日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class BootstrapSecurityUtil {

    private static final String RANDOM = "9451utb@91&vrmio!90iu!89F2QN1V ALAII!K33I*DFA^sA";

    private static final String ENCRYPTED_HEAD = "$$.";

    /**
     * 加密
     *
     * @param s
     * @param secretKey
     * @author WANGWEI
     */
    public static String encrypt(String s, String secretKey) {
        AES aes = new AES(secretKey + RANDOM);
        String encrypted = aes.encrypt(s);
        return encrypted;
    }

    /**
     * 解密
     *
     * @param s
     * @param secretKey
     * @author WANGWEI
     */
    public static String decrypt(String s, String secretKey) {
        AES aes = new AES(secretKey + RANDOM);
        String decrypted = aes.decrypt(s);
        return decrypted;
    }

    /**
     * 解密
     *
     * @param props
     * @param secretKey
     * @author WANGWEI
     */
    public static void decrypt(Properties props, String secretKey) {
        Map<String, String> map = Maps.newHashMap();
        Set<String> set = Sets.newHashSet();
        for (Entry<Object, Object> entry : props.entrySet()) {
            Object key = entry.getKey();
            Object value = entry.getValue();
            if (key instanceof String && value instanceof String) {
                if (((String) key).startsWith(ENCRYPTED_HEAD)) {
                    AES aes = new AES(secretKey + RANDOM);
                    String decryptedValue = null;
                    try {
                        decryptedValue = aes.decrypt((String) value);
                    } catch (Exception e) {
                        throw new ExamCloudRuntimeException(
                                "fail to decrypt value of '" + key + "'");
                    }
                    String newKey = ((String) key).substring(ENCRYPTED_HEAD.length());
                    map.put(newKey, decryptedValue);
                    set.add((String) key);
                }
            }
        }

        for (String s : set) {
            props.remove(s);
        }

        for (Entry<String, String> entry : map.entrySet()) {
            props.put(entry.getKey(), entry.getValue());
        }
    }

    /**
     * 解密
     *
     * @param props
     * @param secretKey
     * @author WANGWEI
     */
    public static void decrypt(Map<String, String> props, String secretKey) {
        Map<String, String> map = Maps.newHashMap();
        Set<String> set = Sets.newHashSet();
        for (Entry<String, String> entry : props.entrySet()) {
            String key = entry.getKey();
            String value = entry.getValue();
            if (key.startsWith(ENCRYPTED_HEAD)) {
                AES aes = new AES(secretKey + RANDOM);
                String decrypted = aes.decrypt((String) value);
                map.put(key.substring(ENCRYPTED_HEAD.length() + 1), decrypted);
                set.add(key);
            }
        }

        for (String s : set) {
            props.remove(s);
        }

        for (Entry<String, String> entry : map.entrySet()) {
            props.put(entry.getKey(), entry.getValue());
        }
    }

}
