package cn.com.qmth.examcloud.web.bootstrap;

import cn.com.qmth.framework.config.center.client.core.EnvProperty;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/**
 * 云配置
 *
 * @author WANGWEI
 * @date 2019年3月25日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class PropertyHolder {

    private static final Logger LOG = LoggerFactory.getLogger(PropertyHolder.class);

    public static String getString(String key) {
        return EnvProperty.getProperty(key);
    }

    public static String getString(String key, String defaultValue) {
        return EnvProperty.getProperty(key, defaultValue);
    }

    public static int getInt(String key, int defaultValue) {
        return EnvProperty.getProperty(key, Integer.class, defaultValue);
    }

    public static long getLong(String key, long defaultValue) {
        return EnvProperty.getProperty(key, Long.class, defaultValue);
    }

    public static boolean getBoolean(String key, boolean defaultValue) {
        return EnvProperty.getProperty(key, Boolean.class, defaultValue);
    }

}
