package cn.com.qmth.examcloud.web.cache;

/**
 * Hash缓存
 *
 * @param <T>
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface HashCache<T> {

    /**
     * 从缓存中获取
     *
     * @param keys
     * @return
     */
    T get(Object[] keys, Object[] subkeys);

    /**
     * 删除缓存
     *
     * @param keys 大key
     */
    void remove(Object... keys);

    /**
     * 刷新缓存
     *
     * @param keys
     */
    void refresh(Object[] keys, Object[] subkeys);

    /**
     * 从数据源（数据库,配置文件等）加载单个缓存项
     *
     * @param keys
     * @return
     */
    T loadFromResource(Object[] keys, Object[] subkeys);

}
