package cn.com.qmth.examcloud.web.cache;

/**
 * 对象缓存
 *
 * @param <T>
 * @author WANGWEI
 * @date 2019年3月13日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface ObjectCache<T> {

    /**
     * 从缓存中获取
     *
     * @param keys
     * @return
     * @author WANGWEI
     */
    T get(Object... keys);

    /**
     * 删除缓存
     *
     * @param keys
     * @author WANGWEI
     */
    void remove(Object... keys);

    /**
     * 刷新缓存
     *
     * @param keys
     * @author WANGWEI
     */
    void refresh(Object... keys);

    /**
     * 从数据源（数据库,配置文件等）加载单个缓存项
     *
     * @param keys
     * @return
     * @author WANGWEI
     */
    T loadFromResource(Object... keys);

}
