package cn.com.qmth.examcloud.web.cloud;

import com.google.common.collect.Maps;

import java.util.Map;

/**
 * 云服务 重定向
 *
 * @author WANGWEI
 * @date 2019年6月5日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class CloudServiceRedirector {

    private static Map<String, String> rules = Maps.newHashMap();

    private static String suffix;

    /**
     * 设置重定向映射
     *
     * @param originAppName 原始服务
     * @param targetAppName 重定向服务
     * @author WANGWEI
     */
    public static void setRedirection(String originAppName, String targetAppName) {
        rules.put(originAppName, targetAppName);
    }

    /**
     * 设置所有服务附加后缀映射.优先级低于 {@link #setRedirection}
     *
     * @param suffixName
     * @author WANGWEI
     * @see #setRedirection
     */
    public static void appendSuffix(String suffixName) {
        CloudServiceRedirector.suffix = suffixName;
    }

    /**
     * 获取重定向映射.不存在时返回null
     *
     * @param originAppName
     * @return
     * @author WANGWEI
     */
    public static String getRedirection(String originAppName) {

        String redirection = rules.get(originAppName);
        if (null != redirection) {
            return redirection;
        }
        if (null != suffix) {
            return originAppName + suffix;
        }

        return null;
    }

}
