package cn.com.qmth.examcloud.web.jpa;

import cn.com.qmth.examcloud.api.commons.exchange.PageInfo;
import org.springframework.data.domain.Page;

import java.util.List;

public class PageUtils {

    public static <T> PageInfo<T> toPageInfo(Page<T> page) {
        PageInfo<T> info = new PageInfo<>();
        info.setTotal(page.getTotalElements());
        info.setPages(page.getTotalPages());
        info.setIndex(page.getNumber());
        info.setSize(page.getNumberOfElements());
        info.setLimit(page.getSize());
        info.setList(page.getContent());
        return info;
    }

    public static <T> PageInfo<T> toPageInfo(Page<?> page, List<T> list) {
        PageInfo<T> info = new PageInfo<>();
        info.setTotal(page.getTotalElements());
        info.setPages(page.getTotalPages());
        info.setIndex(page.getNumber());
        info.setSize(page.getNumberOfElements());
        info.setLimit(page.getSize());
        info.setList(list);
        return info;
    }

}
