package cn.com.qmth.examcloud.web.security;

import cn.com.qmth.examcloud.api.commons.enums.DataRuleType;
import cn.com.qmth.examcloud.api.commons.security.bean.AccessApp;
import cn.com.qmth.examcloud.api.commons.security.bean.User;
import cn.com.qmth.examcloud.api.commons.security.bean.UserDataRule;
import cn.com.qmth.examcloud.web.support.ApiInfo;

/**
 * 资源管理器
 *
 * @author WANGWEI
 * @date 2019年2月15日
 * @Copyright (c) 2018-2020 WANGWEI [QQ:522080330] All Rights Reserved.
 */
public interface ResourceManager {

    /**
     * 获取APP 密钥
     *
     * @param appId
     * @return
     * @author WANGWEI
     */
    AccessApp getAccessApp(Long appId);

    /**
     * 请求的接口是否裸奔
     *
     * @param apiInfo
     * @param mapping
     * @return
     * @author WANGWEI
     */
    boolean isNaked(ApiInfo apiInfo, String mapping);

    /**
     * 分区用户是否有权限访问接口
     *
     * @param user
     * @param apiInfo
     * @param mapping
     * @return
     * @author WANGWEI
     */
    boolean hasPermission(User user, ApiInfo apiInfo, String mapping);

    /**
     * UserDataRule
     *
     * @param userId
     * @param dataRuleType
     * @return
     */
    UserDataRule loadUserDataRule(Long userId, DataRuleType dataRuleType);

}
