package cn.com.qmth.examcloud.web.support;

import javax.servlet.http.HttpServletRequest;

/**
 * spring mvc 方法前校验器
 *
 * @author WANGWEI
 * @date 2019年2月22日
 * @Copyright (c) 2018-2020 WANGWEI [QQ:522080330] All Rights Reserved.
 */
public interface HttpMethodProcessor {

    /**
     * 方法前处理
     *
     * @param request
     * @param args
     * @author WANGWEI
     */
    void beforeMethod(HttpServletRequest request, Object[] args);

    /**
     * 方法执行未抛出异常时执行
     *
     * @param request
     * @param args
     * @param ret
     * @author WANGWEI
     */
    void onSuccess(HttpServletRequest request, Object[] args, Object ret);

    /**
     * 方法执行抛出异常时执行
     *
     * @param request
     * @param args
     * @param e
     * @author WANGWEI
     */
    void onException(HttpServletRequest request, Object[] args, Throwable e);

}
