package cn.com.qmth.examcloud.web.support;

import cn.com.qmth.examcloud.api.commons.exchange.JsonSerializable;
import io.swagger.annotations.ApiModelProperty;

/**
 * 状态响应实体
 *
 * @author WANGWEI
 * @date 2018年5月24日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public class StatusResponse implements JsonSerializable {

    private static final long serialVersionUID = 8393074113722405560L;

    @ApiModelProperty(value = "响应编码", example = "001001", required = true)
    private String code;

    @ApiModelProperty(value = "响应描述", example = "密码错误", required = true)
    private String desc;

    /**
     * 构造函数
     */
    public StatusResponse() {
        super();
    }

    /**
     * 构造函数
     *
     * @param code
     * @param desc
     */
    public StatusResponse(String code, String desc) {
        super();
        this.code = code;
        this.desc = desc;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getDesc() {
        return desc;
    }

    public void setDesc(String desc) {
        this.desc = desc;
    }

}
