package cn.com.qmth.examcloud.web.upyun;

import cn.com.qmth.examcloud.web.filestorage.YunHttpRequest;

import java.io.File;
import java.io.InputStream;

/**
 * 又拍云 服务
 *
 * @author WANGWEI
 * @date 2018年6月29日
 * @Copyright (c) 2018-? http://qmth.com.cn All Rights Reserved.
 */
public interface UpyunService {

    /**
     * 写文件
     *
     * @param siteId
     * @param env
     * @param in
     * @param md5
     * @return
     * @author WANGWEI
     */
    UpYunPathInfo writeFile(String siteId, UpyunPathEnvironmentInfo env, InputStream in,
                            String md5);

    /**
     * 写文件
     *
     * @param siteId
     * @param env
     * @param file
     * @param withMd5
     * @return
     * @author WANGWEI
     */
    UpYunPathInfo writeFile(String siteId, UpyunPathEnvironmentInfo env, File file,
                            boolean withMd5);

    /**
     * 写文件
     *
     * @param siteId
     * @param env
     * @param file
     * @param md5
     * @return
     * @author WANGWEI
     */
    UpYunPathInfo writeFile(String siteId, UpyunPathEnvironmentInfo env, File file, String md5);

    /**
     * 删除文件
     *
     * @param siteId
     * @param filePath
     * @author WANGWEI
     */
    void delete(String siteId, String filePath);

    /**
     * 删除文件
     *
     * @param upyunId
     * @param filePath
     */
    void deleteByUpyunId(String upyunId, String filePath);

    /**
     * 创建http请求
     *
     * @param filePath
     * @param withMd5
     * @return
     * @author WANGWEI
     */
    YunHttpRequest buildUpYunHttpRequest(String siteId, UpyunPathEnvironmentInfo env, String md5);

}
